/*--------------------------------------- Listing 2 -------
 * Demonstration of the signal() function.
 * See Listing 1 for copyright terms.
 *-------------------------------------------------------*/
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>

void ExcHandler ( int Signal, int SubCode );
void main ( void );


void ExcHandler ( int Signal, int SubCode )
{
    /* Ignore further user interrupts */
    if ( signal ( SIGINT, SIG_IGN ) == SIG_ERR )
        abort();

    printf ( "Signal %d, SubCode %d was raised\n", 
             Signal, SubCode );

    /* Restore to our own exception handler */
    if ( signal ( SIGINT, ExcHandler ) == SIG_ERR )
        abort();
}


void main ( void )
{
    void (*OldHandler)( int Signal );

    OldHandler = signal ( SIGINT, ExcHandler );
    if ( OldHandler == SIG_ERR )
        printf( "signal install failed\n" );

    /* Explicitly raise the user-interrupt signal */
    raise ( SIGINT );

    /* Now that we're done, go back to default signal handler */
    if ( signal ( SIGINT, SIG_DFL ) == SIG_ERR )
        abort();
}